//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/.
// 

#include "LaneChangeManeuver.h"

Define_Module(LaneChangeManeuver);

void LaneChangeManeuver::initialize(int stage)
{
    LaneChangeManeuverBase::initialize(stage);
    if (stage == 0) {
        //Initializing members and pointers of your application goes here
    }
    if (stage == 1) {
        //Initializing members that require initialized other modules goes here

    }
}
void LaneChangeManeuver::handleMessage(cMessage *msg)
{
    if (msg->isSelfMessage()) {
        handleSelfMsg(msg);
    }
    else if (UnicastMessage* uc = dynamic_cast<UnicastMessage*>(msg)) {
        cMessage* innerMsg = uc->decapsulate(); //
        delete uc;
        // According to the Platooning implementation, you'll never receive something different than a UnicastMessage here.
        if (LaneChangeBasicSafetyMessage* lcbsm = dynamic_cast<LaneChangeBasicSafetyMessage*>(innerMsg)) {
            // The BSM implementation doesn't strictly follow the U.S. SAE J2735 standard in terms of interval and used fields in the message
            // This is done in order to make the simulation faster and easier for you.
            handleLaneChangeMsg(lcbsm);

        }
        else if (ManeuverMessage* maneuverMsg = dynamic_cast<ManeuverMessage*>(innerMsg)) {
            handleManeuverMsg(maneuverMsg);
        }
        else if (PlatooningBeacon* pBeacon = dynamic_cast<PlatooningBeacon*>(innerMsg)) {
            handlePlatooningBeacon(pBeacon);
        }
    }
}

void LaneChangeManeuver::handleLaneChangeMsg(LaneChangeBasicSafetyMessage* lcbsm){
    //TODO: Magic goes here
    delete lcbsm;
}
void LaneChangeManeuver::handlePlatooningBeacon(PlatooningBeacon* beacon) {
    //TODO: Magic goes here
    delete beacon;
}

void LaneChangeManeuver::handleManeuverMsg(ManeuverMessage* maneuverMsg){
    //TODO: Magic goes here
    delete maneuverMsg;
}

void LaneChangeManeuver::handleSelfMsg(cMessage *msg) {
    //TODO: Magic goes here
}

void LaneChangeManeuver::finish() {
    //statistics recording goes here
}
