//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/.
// 

#ifndef __PLEXE_VEINS_LANECHANGEMANEUVER_H_
#define __PLEXE_VEINS_LANECHANGEMANEUVER_H_

#include "LaneChangeManeuverBase.h"
#include <algorithm>
class LaneChangeManeuver : public LaneChangeManeuverBase
{
public:
    virtual void initialize(int stage) override;
    virtual void finish() override;
protected:
        virtual void handleMessage(cMessage *msg) override;
        virtual void handleSelfMsg(cMessage *msg) override;
        void handleManeuverMsg(ManeuverMessage* maneuverMsg);
        void handlePlatooningBeacon(PlatooningBeacon* beacon);
        void handleLaneChangeMsg(LaneChangeBasicSafetyMessage* lcbsm);
public:
        LaneChangeManeuver() {
            appl = 0;
        }
};

#endif
