//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/.
// 

#ifndef __PLEXE_VEINS_LANECHANGEMANEUVERBASE_H_
#define __PLEXE_VEINS_LANECHANGEMANEUVERBASE_H_

#include <omnetpp.h>

#include "veins/modules/application/platooning/scenarios/BaseScenario.h"
#include "veins/modules/application/platooning/protocols/BaseProtocol.h"
#include "veins/modules/application/platooning/apps/BaseApp.h"

#include "veins/modules/application/platooning/messages/LaneChangeBasicSafetyMessage_m.h"
#include "veins/modules/application/platooning/messages/ManeuverMessage_m.h"
#include "veins/modules/mobility/traci/TraCIScenarioManager.h"

class LaneChangeManeuverBase : public BaseScenario
{
public:
    static const int MANEUVER_TYPE = 1337;
    static const int BEACON_TYPE = 12345;
    int myPosition ;
protected:
    //application layer, used to stop the simulation
    BaseApp *appl;
    //sumo vehicle type of platooning cars
    std::string platooningVType;

    void changeLane(int laneIndex);
    int getBackId();
    int getFrontId();
    int getLaneId();
    int getMyPlatoonId();
    Coord getMyPosition();
    int getPlatoonSize();
    double getVehicleLength();
    bool isLeader();
    virtual void initialize(int stage);
    void sendManeuverMessage(cPacket *msg, int destination) ;
    void setPlatoonSpeed(double desiredSpeed);
};

#endif
